<?php 
/*
Plugin Name:  PayPing Multi-Pay Gateway For Dokan
Plugin URI:   https://payping.ir
Description:  افزونه پرداخت تسهیمی و تسویه خودکار پی‌پینگ.
Version:      1.0.0
Author:       Mahdi Sarani
Author URI:   https://mahdisarani.ir
License:      GPL2
License URI:  https://www.gnu.org/licenses/gpl-2.0.html
Text Domain:  multipayPayPing
Domain Path:  /lang
*/
if(!defined('ABSPATH')) exit;

define('MPPDGDIR', plugin_dir_path( __FILE__ ));

require_once( MPPDGDIR.'inc/admin.php' );
require_once( MPPDGDIR.'inc/dokan.php' );

// COD Fee based on vendors count 
add_action( 'woocommerce_cart_calculate_fees', 'multi_pay_payping_dokan_cod_fee_vendors_based' );
function multi_pay_payping_dokan_cod_fee_vendors_based ( $cart ) {
    if ( is_admin() && ! defined( 'DOING_AJAX' ) )
        return;
    
    // Only checkout page
    if( ! ( is_checkout() && ! is_wc_endpoint_url() ) )
        return;
        
    $fee_by_vendor = 2; // HERE set the fee by vendor
    $vendors_array = array(); // Initializing

    // Loop through cart items
    foreach ( $cart->get_cart() as $item ) {
        $vendor_id = get_post_field('post_author', $item['product_id']); // Get the vendor_id
    
        // Set in an indexed array to get how many vendors
        $vendors_array[$vendor_id] = $vendor_id;
    }

    $fee_total = count($vendors_array) * $fee_by_vendor; // Get fee total by vendor

    if ( 'cod' === WC()->session->get( 'chosen_payment_method' ) ) {
        $cart->add_fee( 'Cash On Delivery Fee', $fee_total, true ); // Apply the fee
    }
}

// jQuery - Update checkout on methode payment change
add_action( 'wp_footer', 'multi_pay_payping_payment_refresh_checkout_js' );
function multi_pay_payping_payment_refresh_checkout_js() {
    // Only checkout page
    if ( ! ( is_checkout() && ! is_wc_endpoint_url() ) )
        return; // Exit
    ?>
    <script type="text/javascript">
    jQuery( function($){
        $('form.checkout').on('change', 'input[name="payment_method"]', function(){
            $(document.body).trigger('update_checkout');
        });
    });
    </script>
    <?php
}